package cn.newfeifan.mall.module.product.dal.mysql.spuapply;


import cn.newfeifan.mall.framework.common.pojo.PageResult;
import cn.newfeifan.mall.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.newfeifan.mall.framework.mybatis.core.mapper.BaseMapperX;
import cn.newfeifan.mall.module.product.dal.dataobject.spuapply.SpuApplyDO;
import org.apache.ibatis.annotations.Mapper;
import cn.newfeifan.mall.module.product.controller.admin.spuapply.vo.*;
import org.apache.ibatis.annotations.Select;

/**
 * 商品spu申请 Mapper
 *
 * @author 非繁人
 */
@Mapper
public interface SpuApplyMapper extends BaseMapperX<SpuApplyDO> {

    default PageResult<SpuApplyDO> selectPage(SpuApplyPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<SpuApplyDO>()
                .likeIfPresent(SpuApplyDO::getName, reqVO.getName())
                .eqIfPresent(SpuApplyDO::getKeyword, reqVO.getKeyword())
                .eqIfPresent(SpuApplyDO::getIntroduction, reqVO.getIntroduction())
                .eqIfPresent(SpuApplyDO::getDescription, reqVO.getDescription())
                .eqIfPresent(SpuApplyDO::getProducerArea, reqVO.getProducerArea())
                .eqIfPresent(SpuApplyDO::getSpuType, reqVO.getSpuType())
                .eqIfPresent(SpuApplyDO::getCategoryId, reqVO.getCategoryId())
                .eqIfPresent(SpuApplyDO::getBrandId, reqVO.getBrandId())
                .eqIfPresent(SpuApplyDO::getPicUrl, reqVO.getPicUrl())
                .eqIfPresent(SpuApplyDO::getSliderPicUrls, reqVO.getSliderPicUrls())
                .eqIfPresent(SpuApplyDO::getSort, reqVO.getSort())
                .eqIfPresent(SpuApplyDO::getStatus, reqVO.getStatus())
                .eqIfPresent(SpuApplyDO::getSpecType, reqVO.getSpecType())
                .eqIfPresent(SpuApplyDO::getPrice, reqVO.getPrice())
                .eqIfPresent(SpuApplyDO::getMarketPrice, reqVO.getMarketPrice())
                .eqIfPresent(SpuApplyDO::getCostPrice, reqVO.getCostPrice())
                .eqIfPresent(SpuApplyDO::getStock, reqVO.getStock())
                .eqIfPresent(SpuApplyDO::getDeliveryTypes, reqVO.getDeliveryTypes())
                .eqIfPresent(SpuApplyDO::getDeliveryTemplateId, reqVO.getDeliveryTemplateId())
                .eqIfPresent(SpuApplyDO::getGiveIntegral, reqVO.getGiveIntegral())
                .eqIfPresent(SpuApplyDO::getSubCommissionType, reqVO.getSubCommissionType())
                .eqIfPresent(SpuApplyDO::getSalesCount, reqVO.getSalesCount())
                .eqIfPresent(SpuApplyDO::getVirtualSalesCount, reqVO.getVirtualSalesCount())
                .eqIfPresent(SpuApplyDO::getBrowseCount, reqVO.getBrowseCount())
                .betweenIfPresent(SpuApplyDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(SpuApplyDO::getShopId, reqVO.getShopId())
                .eqIfPresent(SpuApplyDO::getMerchantId, reqVO.getMerchantId())
                .eqIfPresent(SpuApplyDO::getHidden, reqVO.getHidden())
                .eqIfPresent(SpuApplyDO::getPromotionFee, reqVO.getPromotionFee())
                .eqIfPresent(SpuApplyDO::getSpuPayType, reqVO.getSpuPayType())
                .eqIfPresent(SpuApplyDO::getHighPrecision, reqVO.getHighPrecision())
                .eqIfPresent(SpuApplyDO::getHighPrecisionPrice, reqVO.getHighPrecisionPrice())
                .eqIfPresent(SpuApplyDO::getApplyMemberUserId, reqVO.getApplyMemberUserId())
                .eqIfPresent(SpuApplyDO::getCheckSystemUserId, reqVO.getCheckSystemUserId())
                .betweenIfPresent(SpuApplyDO::getCheckTime, reqVO.getCheckTime())
                .eqIfPresent(SpuApplyDO::getCheckComment, reqVO.getCheckComment())
                .eqIfPresent(SpuApplyDO::getCheckStatus, reqVO.getCheckStatus())
                .orderByDesc(SpuApplyDO::getId));
    }

    @Select("select name from sale_shop where id=#{id}")
    String selectShopNameById(Long id);
}